#include "StdAfx.h"
#include "TestP4BridgeServerLogging.h"

#include "..\p4bridge\P4BridgeClient.h"
#include "..\p4bridge\P4BridgeServer.h"

#include <strtable.h>
#include <strarray.h>

CREATE_TEST_SUITE(TestP4BridgeServerLogging)

TestP4BridgeServerLogging::TestP4BridgeServerLogging(void)
{
    UnitTestSuite::RegisterTest(LogMessageTest, "LogMessageTest");
}

TestP4BridgeServerLogging::~TestP4BridgeServerLogging(void)
{
}

bool TestP4BridgeServerLogging::Setup()
{
    return true;
}

bool TestP4BridgeServerLogging::TearDown()
{
    return true;
}

int _stdcall TestP4BridgeServerLogging::LogCallback(int level, const char* file, int line, const char* message)
{
    if ((level == 3) && (strncmp( message, "Info", 4 ) == 0))
        return 1;

    if ((level == 0) && (strncmp( message, "Fatal:1", 7 ) == 0))
        return 1;

    if ((level == 42) && (strncmp( message, "Debug:42", 8 ) == 0))
        return 1;

    return 0;
}

bool TestP4BridgeServerLogging::LogMessageTest()
{
    P4BridgeServer::SetLogCallFn(LogCallback);

    ASSERT_TRUE(LOG_INFO("Info"));

    ASSERT_TRUE(LOG_FATAL1("Fatal:%s", "1"));

    ASSERT_TRUE(LOG_DEBUG2(42, "Debug:%c%c", '4', '2'));

    return true;
}